﻿

#include <iostream>
#include <vector>
#include"Data.h"
#include <string>
#include "Person.h"
int main()
{
	std::cout << "---------------------------" << " Data Test " << "---------------------------" << std::endl;
	bool b = true;
	while (b) {
		std::cout << "1: createData\n2: createDataContainer\n3: loadData\n4: streamloadData" << std::endl;
		std::cout << "5: modify\n6: modify_iterator\n7: modify_for_each\n8: outputResult\n9: outputResultContainer" << std::endl;
		std::cout << "10: outputResultContainerCopy\n11: clear screen\n12: exit" << std::endl;
		int code;
		std::cin >> code;
		std::vector<int> d;
		auto print = [](std::vector<int> cont) {
			for (auto i = cont.begin(); i != cont.end(); ++i) {
				std::cout << *i << " ";
			}
		};
		try {
			switch (code) {
			case 1: createData("1.txt"); break;
			case 2: createDataGenerate<std::vector<int>>("1.txt"); break;
			case 3: print(loadData<std::vector<int>>("1.txt")); break;
			case 4: print(loadDataIterator<std::vector<int>>("1.txt")); break;
			case 5: Modify1<std::vector<int>>(d); break;
			case 6: Modify2<std::vector<int>>(d.begin(),d.end()); break;
			case 7: Modify3<std::vector<int>>(d); break;
			case 8: Modify4<std::vector<int>>("2.txt"); break;
			case 9: outputResult<std::vector<int>>("2.txt",d); break;
			case 10: outputResult<std::vector<int>>("2.txt", d); break;
			case 11: system("cls"); break;
			case 12: b = false; break;
			default: std::cout << "Entered code is wrong!" << std::endl;
			}
		}
		catch (std::exception& error) {
			std::cerr << error.what() << std::endl;
		}
	}
	std::cout << std::endl << "---------------------------" << " TravelCompany Test " << "---------------------------" << std::endl;
	b = true;
	while (b) {
		std::cout << "1: create file\n2: add\n3: delete data\n4: replacement" << std::endl;
		std::cout << "5: convert to txt\n6:find full name\n7:find department number\n8:find_enrollment_date\n9: clear screen\n10: exit" << std::endl;
		int i;
		std::cin >> i;
		std::ofstream file_write("1.bin", std::ios::binary);  
		std::ifstream file_read("1.bin", std::ios::binary);  
		std::ofstream file2_write("2.bin", std::ios::binary); 
		Person data;
		std::cin >> data;
		try {
			switch (i) {
			case 1: Person::create_file(file_write); break;
			case 2: data.add(file_write); break;
			case 3: data.delete_data(file2_write, file_read); break;
			case 4: data.replacement(file2_write, file_read, data); break;
			case 5: data.convert_to_txt("2"); break;
			case 6: data.find_full_name("Oleg Ivanov", file_write); break;
			case 7: data.find_department_number(1, file_write); break;
			case 8: data.find_enrollment_date("20.11.19", file_write); break;
			case 9: system("cls"); break;
			case 10: b = false; break;
			default: std::cout << "Entered code is wrong!" << std::endl;
			}
		}
		catch (std::exception& error) {
			std::cerr << error.what() << std::endl;
		}
	}


}
